
namespace PlaywrightStudy.Test
{
    public class PlaywrightTest
    {
        /// <summary>
        /// ͨ API װ
        /// Ȼжְװʽ
        /// </summary>
        [Fact]
        public void Install_Browsers_Test()
        {
            var exitCode = Microsoft.Playwright.Program.Main(new[] { "install" });
            if (exitCode != 0)
            {
                throw new Exception($"Playwright exited with code {exitCode}");
            }
        }

        #region Edge
        [Fact]
        public async void Baidu_Edge_Test()
        {
            using var playwright = await Playwright.CreateAsync();

            //await using var browser = await playwright.Chromium.LaunchAsync(new BrowserTypeLaunchOptions()
            //{
            //    SlowMo              = 50,           //
            //    Headless            =  false,        // رͷģʽ(н)
            //    Channel             = "msedge",     // ָchrome()
            //    Devtools            = false,         // ÿ߹
            //    ChromiumSandbox     = false,        // رɳ
            //    ExecutablePath      = string.Empty, // ִָļλãԶѰ ms-playwright ص
            //    Args = new[] { "--enable-automation=true", "--disable-blink-features=AutomationControlled" }, // ֹselenium
            //});

            //ĬEdge
            await using var browser = await playwright.Chromium.LaunchAsync(new BrowserTypeLaunchOptions() 
            {
                //رͷģʽ(н)
                Headless = false,
            });

            //
            var browserContexts = browser.Contexts;

            //ҳ
            var page = await browser.NewPageAsync();

            //ҳӦ
            var response = await page.GotoAsync("https://www.baidu.com/");

            //λ
            var searchBoxLocator = page.GetByRole(AriaRole.Textbox).Nth(0);

            //Ԫظ
            var count = await searchBoxLocator.CountAsync();

            //xUnit
            Assert.True(count > 0);

            //Playwright
            await Microsoft.Playwright.Assertions.Expect(searchBoxLocator).ToHaveCountAsync(1);

            //ǰ(һȫ)
            await searchBoxLocator.FillAsync("Playwright");

            //ݺ󲿷(ģû룺ÿַ֮ʱ)
            //await textboxLocator.TypeAsync(".net", new LocatorTypeOptions { Delay = 1000 });

            //ݺ󲿷(ģû룺ÿַ֮ʱ)
            await searchBoxLocator.PressSequentiallyAsync(".NET", new LocatorPressSequentiallyOptions { Delay = 200 });

            //س:ȷ[ַ,Ҳϼ("Shift+Home""Alt+Enter")]
            //await searchBoxLocator.PressAsync("Enter");

            //ť
            var searchButtonLocator = page.Locator("#su");

            var searchButtonCount = await searchButtonLocator.CountAsync();

            //:ťҵ
            await Microsoft.Playwright.Assertions.Expect(searchButtonLocator).ToHaveCountAsync(1);

            //ť
            await searchButtonLocator.ClickAsync();

            //ʹ page.Keyboard  page.Mouse ģ̺Ĳ
            //await page.Keyboard.PressAsync("Enter");
            //await page.Mouse.ClickAsync(100, 100);

            await page.WaitForLoadStateAsync();

            //ҳͼ
            await page.ScreenshotAsync(new()
            {
                Path = "Baidu.Edge.Screenshot.png",
                FullPage = true, //ҳͼ
            });

            //Ԫؽͼ
            var paggerLocator = page.Locator("#page");

            //޴УԪؽͼ
            var paagerCount = await paggerLocator.CountAsync();

            await paggerLocator.ScreenshotAsync(new LocatorScreenshotOptions() 
            {
                Path = "Baidu.Edge.ByPage.Screenshot.png",
                //Quality = 100,
                Type = ScreenshotType.Png
            });

            //ҳΪPdfļ
            await page.PdfAsync(new()
            {
                Path = "Baidu.Edge.pdf",
                DisplayHeaderFooter = false,
                Format = "A4"
            });
        }

        [Fact]
        public async void Bing_Edge_Test()
        {
            using var playwright = await Playwright.CreateAsync();

            //ĬEdge
            await using var browser = await playwright.Chromium.LaunchAsync(new BrowserTypeLaunchOptions()
            {
                //رͷģʽ(н)
                Headless = false,
            });

            //
            var browserContexts = browser.Contexts;

            //ҳ
            var page = await browser.NewPageAsync();

            //ҳӦ
            var response = await page.GotoAsync("https://cn.bing.com/");

            //ɹ
            Assert.Equal(200, response?.Status);

            //λ
            var searchBoxLocator = page.Locator("input#sb_form_q");

            //
            var count = await searchBoxLocator.CountAsync();

            //xUnit
            Assert.True(count > 0);

            //Playwright
            await Microsoft.Playwright.Assertions.Expect(searchBoxLocator).ToHaveCountAsync(1);

            //ǰ(һȫ)
            //await searchBoxLocator.FillAsync("Playwright");

            //ݺ󲿷(ģû룺ÿַ֮ʱ)
            await searchBoxLocator.PressSequentiallyAsync("Playwright.NET", new LocatorPressSequentiallyOptions { Delay = 200 });

            //س:ȷ[ַ,Ҳϼ("Shift+Home""Alt+Enter")]
            await searchBoxLocator.PressAsync("Enter");

            await page.WaitForLoadStateAsync();

            //ͼ
            await page.ScreenshotAsync(new()
            {
                Path = "Bing.Edge.Screenshot.png"
            });

            //ҳΪPdfļ
            await page.PdfAsync(new()
            {
                Path = "Bing.Edge.pdf",
                DisplayHeaderFooter = false,
                Format = "A4"
            });
        }

        #endregion

        #region Chrome

        /// <summary>
        /// Ƚϸ
        /// </summary>
        [Fact]
        public async void Baidu_Chrome_Test()
        {
            using var playwright = await Playwright.CreateAsync();

            //ָ chrome
            await using var browser = await playwright.Chromium.LaunchAsync(new BrowserTypeLaunchOptions()
            {
                SlowMo              = 50,           //
                Headless            = false,        // رͷģʽ(н)
                Channel             = "chrome",     // ָchrome()
                Devtools            = false,         // ÿ߹
                ChromiumSandbox     = true,        // رɳ
                ExecutablePath      = string.Empty, // ִָļλãԶѰ ms-playwright ص
                DownloadsPath       = "download",
            });

            //ҳ
            var page = await browser.NewPageAsync();

            //ҳӦ
            var response = await page.GotoAsync("https://www.baidu.com/");

            //λ
            var searchBoxLocator = page.GetByRole(AriaRole.Textbox).Nth(0);

            //Ԫظ
            var count = await searchBoxLocator.CountAsync();

            //xUnit
            Assert.True(count > 0);

            //Playwright
            await Microsoft.Playwright.Assertions.Expect(searchBoxLocator).ToHaveCountAsync(1);

            //ǰ(һȫ)
            //await searchBoxLocator.FillAsync("Playwright");

            //ݺ󲿷(ģû룺ÿַ֮ʱ)
            await searchBoxLocator.PressSequentiallyAsync("Playwright.NET", new LocatorPressSequentiallyOptions { Delay = 200 });

            //س:ȷ[ַ,Ҳϼ("Shift+Home""Alt+Enter")]
            await searchBoxLocator.PressAsync("Enter");

            //ȴ
            await page.WaitForLoadStateAsync(LoadState.DOMContentLoaded);

            //ͼ
            await page.ScreenshotAsync(new()
            {
                Path = "Baidu.Chrome.Screenshot.png"
            });

            //ҳΪPdfļ
            await page.PdfAsync(new()
            {
                Path = "Baidu.Chrome.pdf",
                DisplayHeaderFooter = false,
                Format = "A4"
            });
        }

        
        #endregion

        #region Firefox
        [Fact]
        public async void Baidu_Firefox_Test()
        {
            using var playwright = await Playwright.CreateAsync();

            //ָ chrome
            await using var browser = await playwright.Firefox.LaunchAsync(new BrowserTypeLaunchOptions()
            {
                SlowMo = 50,           //
                Headless = false,        // رͷģʽ(н
                Devtools = false,         // ÿ߹
                ChromiumSandbox = true,        // رɳ
                ExecutablePath = string.Empty, // ִָļλãԶѰ ms-playwright ص
                DownloadsPath = "download",
            });

            //ҳ
            var page = await browser.NewPageAsync();

            //ҳӦ
            var response = await page.GotoAsync("https://www.baidu.com/");

            //λ
            var searchBoxLocator = page.GetByRole(AriaRole.Textbox).Nth(0);

            //Ԫظ
            var count = await searchBoxLocator.CountAsync();

            //xUnit
            Assert.True(count > 0);

            //Playwright
            await Microsoft.Playwright.Assertions.Expect(searchBoxLocator).ToHaveCountAsync(1);

            //ǰ(һȫ)
            //await searchBoxLocator.FillAsync("Playwright");

            //ݺ󲿷(ģû룺ÿַ֮ʱ)
            await searchBoxLocator.PressSequentiallyAsync("Playwright.NET", new LocatorPressSequentiallyOptions { Delay = 200 });

            //س:ȷ[ַ,Ҳϼ("Shift+Home""Alt+Enter")]
            await searchBoxLocator.PressAsync("Enter");

            //ȴ
            await page.WaitForLoadStateAsync(LoadState.DOMContentLoaded);

            //ͼ
            await page.ScreenshotAsync(new()
            {
                Path = "Baidu.Firefox.Screenshot.png"
            });

            //ҳΪPdfļ:FireFox֧
            //await page.PdfAsync(new()
            //{
            //    Path = "Baidu.Firefox.pdf",
            //    DisplayHeaderFooter = false,
            //    Format = "A4"
            //});
        }

        [Fact]
        public async void Bing_Firefox_Test()
        {
            using var playwright = await Playwright.CreateAsync();

            //ָ chrome
            await using var browser = await playwright.Firefox.LaunchAsync(new BrowserTypeLaunchOptions()
            {
                SlowMo = 50,           //
                Headless = false,        // رͷģʽ(н
                Devtools = false,         // ÿ߹
                ChromiumSandbox = true,        // رɳ
                ExecutablePath = string.Empty, // ִָļλãԶѰ ms-playwright ص
                DownloadsPath = "download",
            });

            //
            var browserContexts = browser.Contexts;

            //ҳ
            var page = await browser.NewPageAsync();

            //ҳӦ
            var response = await page.GotoAsync("https://cn.bing.com/");

            //ɹ
            Assert.Equal(200, response?.Status);

            //λ
            var searchBoxLocator = page.Locator("input#sb_form_q");

            //
            var count = await searchBoxLocator.CountAsync();

            //xUnit
            Assert.True(count > 0);

            //Playwright
            await Microsoft.Playwright.Assertions.Expect(searchBoxLocator).ToHaveCountAsync(1);

            //ǰ(һȫ)
            //await searchBoxLocator.FillAsync("Playwright");

            //ݺ󲿷(ģû룺ÿַ֮ʱ)
            await searchBoxLocator.PressSequentiallyAsync("Playwright.NET", new LocatorPressSequentiallyOptions { Delay = 200 });

            //س:ȷ[ַ,Ҳϼ("Shift+Home""Alt+Enter")]
            await searchBoxLocator.PressAsync("Enter");

            await page.WaitForLoadStateAsync();

            //ͼ
            await page.ScreenshotAsync(new()
            {
                Path = "Bing.Firefox.Screenshot.png"
            });

            //ҳΪPdfļ
            //await page.PdfAsync(new()
            //{
            //    Path = "Bing.Firefox.pdf",
            //    DisplayHeaderFooter = false,
            //    Format = "A4"
            //});
        }
        #endregion

        #region WebKit
        [Fact]
        public async void Baidu_WebKit_Test()
        {
            using var playwright = await Playwright.CreateAsync();

            //ָ chrome
            await using var browser = await playwright.Webkit.LaunchAsync(new BrowserTypeLaunchOptions()
            {
                SlowMo              = 50,               //
                Headless            = false,            // رͷģʽ(н
                Devtools            = false,            // ÿ߹
                ChromiumSandbox     = true,             // رɳ
                ExecutablePath      = string.Empty,     // ִָļλãԶѰ ms-playwright ص
                DownloadsPath       = "download",
            });

            //ҳ
            var page = await browser.NewPageAsync();

            //ҳӦ
            var response = await page.GotoAsync("https://www.baidu.com/");

            //λ
            var searchBoxLocator = page.GetByRole(AriaRole.Textbox).Nth(0);

            //Ԫظ
            var count = await searchBoxLocator.CountAsync();

            //xUnit
            Assert.True(count > 0);

            //Playwright
            await Microsoft.Playwright.Assertions.Expect(searchBoxLocator).ToHaveCountAsync(1);

            //ǰ(һȫ)
            //await searchBoxLocator.FillAsync("Playwright");

            //ݺ󲿷(ģû룺ÿַ֮ʱ)
            await searchBoxLocator.PressSequentiallyAsync("Playwright.NET", new LocatorPressSequentiallyOptions { Delay = 200 });

            //س:ȷ[ַ,Ҳϼ("Shift+Home""Alt+Enter")]
            await searchBoxLocator.PressAsync("Enter");

            //ȴ
            await page.WaitForLoadStateAsync(LoadState.DOMContentLoaded);

            //ͼ
            await page.ScreenshotAsync(new()
            {
                Path = "Baidu.WebKit.Screenshot.png"
            });

            //ҳΪPdfļ:FireFox֧
            //await page.PdfAsync(new()
            //{
            //    Path = "Baidu.WebKit.pdf",
            //    DisplayHeaderFooter = false,
            //    Format = "A4"
            //});
        }
        #endregion

        #region WebAPI
        /// <summary>
        ///  ʹѽӿ
        /// </summary>
        [Fact]
        public async Task WebAPI_TestAsync()
        {
            //https://docs.tenapi.cn/ ѽӿ
            //IPѯ https://tenapi.cn/v2/getip?ip=192.168.1.1

            using var playwright = await Playwright.CreateAsync();
            var apiRequestContext = await playwright.APIRequest.NewContextAsync(new APIRequestNewContextOptions() 
            {
                BaseURL="https://tenapi.cn",
                ExtraHTTPHeaders = new Dictionary<string, string>()
                {
                    { "Accept","text/html"},

                     //ȫ֤
                    { "Authorization","Bear a.b.c"}
                },
                //HttpCredentials = new HttpCredentials() { Origin="http://localhost:8060",Username="admin",Password="123456" },
                //IgnoreHTTPSErrors = true,   //ôʱ֤
                Timeout = 30*1000,
            });

            var apiResponse = await apiRequestContext.GetAsync("v2/getip?ip=192.168.1.1");

            Assert.True(apiResponse.Ok);

            var ipResult = await apiResponse.JsonAsync<TenApiReturnBase<GetIP>>();

            Assert.NotNull(ipResult);
            Assert.IsType<TenApiReturnBase<GetIP>>(ipResult);

            Assert.Equal("ȡɹ", ipResult.msg);
           
        }

        /// <summary>
        ///  ʹFiddlerץFiddlerΪ,Fiddler
        /// </summary>
        [Fact]
        public async Task WebAPI_FiddleProxy_TestAsync()
        {
            //https://docs.tenapi.cn/ ѽӿ
            //IPѯ https://tenapi.cn/v2/getip?ip=192.168.1.1

            using var playwright = await Playwright.CreateAsync();
            var apiRequestContext = await playwright.APIRequest.NewContextAsync(new APIRequestNewContextOptions()
            {
                BaseURL = "https://tenapi.cn",
                ExtraHTTPHeaders = new Dictionary<string, string>()
                {
                    { "Accept","text/html"},
                    { "Authorization","Bear a.b.c"}
                },
                IgnoreHTTPSErrors = true,   //ôʱ֤
                Timeout = 30 * 1000,
                Proxy = new Proxy() { Server = "http://127.0.0.1:8888" }
            });

            var apiResponse = await apiRequestContext.GetAsync("v2/getip?ip=192.168.1.1");

            Assert.True(apiResponse.Ok);

            var ipResult = await apiResponse.JsonAsync<TenApiReturnBase<GetIP>>();

            Assert.NotNull(ipResult);
            Assert.IsType<TenApiReturnBase<GetIP>>(ipResult);

            Assert.Equal("ȡɹ", ipResult.msg);

        }
        #endregion
    }
}